Index: contrib/ntp/libntp/Makefile.am
===================================================================
--- contrib/ntp/libntp/Makefile.am	(版本 314126)
+++ contrib/ntp/libntp/Makefile.am	(版本 316722)
@@ -119,11 +119,15 @@
 EXTRA_libntp_a_SOURCES = adjtimex.c
 
 AM_CFLAGS = $(CFLAGS_NTP)
+AM_CFLAGS += $(NTP_HARD_CFLAGS)
 
 AM_CPPFLAGS  = $(NTP_INCS)
 AM_CPPFLAGS += $(LIBOPTS_CFLAGS)
 AM_CPPFLAGS += $(CPPFLAGS_NTP)
+AM_CPPFLAGS += $(NTP_HARD_CPPFLAGS)
 
+AM_LDFLAGS = $(NTP_HARD_LDFLAGS)
+
 EXTRA_DIST = README
 
 include $(top_srcdir)/depsver.mf
Index: contrib/ntp/libntp/a_md5encrypt.c
===================================================================
--- contrib/ntp/libntp/a_md5encrypt.c	(版本 314126)
+++ contrib/ntp/libntp/a_md5encrypt.c	(版本 316722)
@@ -11,7 +11,6 @@
 #include "ntp.h"
 #include "ntp_md5.h"	/* provides OpenSSL digest API */
 #include "isc/string.h"
-#include "libssl_compat.h"
 /*
  * MD5authencrypt - generate message digest
  *
Index: contrib/ntp/libntp/authkeys.c
===================================================================
--- contrib/ntp/libntp/authkeys.c	(版本 314126)
+++ contrib/ntp/libntp/authkeys.c	(版本 316722)
@@ -250,7 +250,7 @@
 	i = (keycount > 0)
 		? keycount
 		: MEMINC;
-	sk = emalloc_zero(i * sizeof(*sk) + MOREMEM_EXTRA_ALLOC);
+	sk = eallocarrayxz(i, sizeof(*sk), MOREMEM_EXTRA_ALLOC);
 #ifdef DEBUG
 	base = sk;
 #endif
Index: contrib/ntp/libntp/libssl_compat.c
===================================================================
--- contrib/ntp/libntp/libssl_compat.c	(版本 314126)
+++ contrib/ntp/libntp/libssl_compat.c	(版本 316722)
@@ -15,17 +15,20 @@
  * ---------------------------------------------------------------------
  */
 #include "config.h"
-
-#include <string.h>
-#include <openssl/bn.h>
-#include <openssl/evp.h>
-
 #include "ntp_types.h"
 
 /* ----------------------------------------------------------------- */
-#if OPENSSL_VERSION_NUMBER < 0x10100000L
+#ifdef OPENSSL
+# include <string.h>
+# include <openssl/bn.h>
+# include <openssl/evp.h>
+#endif
 /* ----------------------------------------------------------------- */
 
+/* ----------------------------------------------------------------- */
+#if defined(OPENSSL) && OPENSSL_VERSION_NUMBER < 0x10100000L
+/* ----------------------------------------------------------------- */
+
 #include "libssl_compat.h"
 #include "ntp_assert.h"
 
@@ -325,7 +328,7 @@
 }
 
 /* ----------------------------------------------------------------- */
-#else /* OPENSSL_VERSION_NUMBER >= v1.1.0 */
+#else /* OPENSSL && OPENSSL_VERSION_NUMBER >= v1.1.0 */
 /* ----------------------------------------------------------------- */
 
 NONEMPTY_TRANSLATION_UNIT
Index: contrib/ntp/libntp/ssl_init.c
===================================================================
--- contrib/ntp/libntp/ssl_init.c	(版本 314126)
+++ contrib/ntp/libntp/ssl_init.c	(版本 316722)
@@ -13,52 +13,65 @@
 #include <lib_strbuf.h>
 
 #ifdef OPENSSL
+#include "openssl/crypto.h"
 #include "openssl/err.h"
 #include "openssl/evp.h"
+#include "openssl/opensslv.h"
 #include "libssl_compat.h"
 
-void	atexit_ssl_cleanup(void);
-
 int ssl_init_done;
 
+#if OPENSSL_VERSION_NUMBER < 0x10100000L
+
+static void
+atexit_ssl_cleanup(void)
+{
+	if (!ssl_init_done)
+		return;
+
+	ssl_init_done = FALSE;
+	EVP_cleanup();
+	ERR_free_strings();
+}
+
 void
 ssl_init(void)
 {
 	init_lib();
 
-	if (ssl_init_done)
-		return;
-
-	ERR_load_crypto_strings();
-	OpenSSL_add_all_algorithms();
-	atexit(&atexit_ssl_cleanup);
-
-	ssl_init_done = TRUE;
+	if ( ! ssl_init_done) {
+	    ERR_load_crypto_strings();
+	    OpenSSL_add_all_algorithms();
+	    atexit(&atexit_ssl_cleanup);
+	    ssl_init_done = TRUE;
+	}
 }
 
+#else /* OPENSSL_VERSION_NUMBER >= 0x10100000L */
 
 void
-atexit_ssl_cleanup(void)
+ssl_init(void)
 {
-	if (!ssl_init_done)
-		return;
-
-	ssl_init_done = FALSE;
-	EVP_cleanup();
-	ERR_free_strings();
+	init_lib();
+	ssl_init_done = TRUE;
 }
 
+#endif /* OPENSSL_VERSION_NUMBER */
 
+
 void
 ssl_check_version(void)
 {
-	if ((SSLeay() ^ OPENSSL_VERSION_NUMBER) & ~0xff0L) {
+	u_long	v;
+	
+	v = OpenSSL_version_num();
+	if ((v ^ OPENSSL_VERSION_NUMBER) & ~0xff0L) {
 		msyslog(LOG_WARNING,
 		    "OpenSSL version mismatch. Built against %lx, you have %lx",
-		    (u_long)OPENSSL_VERSION_NUMBER, SSLeay());
+		    (u_long)OPENSSL_VERSION_NUMBER, v);
 		fprintf(stderr,
 		    "OpenSSL version mismatch. Built against %lx, you have %lx\n",
-		    (u_long)OPENSSL_VERSION_NUMBER, SSLeay());
+		    (u_long)OPENSSL_VERSION_NUMBER, v);
 	}
 
 	INIT_SSL();
Index: contrib/ntp/libparse/Makefile.am
===================================================================
--- contrib/ntp/libparse/Makefile.am	(版本 314126)
+++ contrib/ntp/libparse/Makefile.am	(版本 316722)
@@ -81,11 +81,15 @@
 	$(NULL)
 
 AM_CFLAGS = $(CFLAGS_NTP)
+AM_CFLAGS += $(NTP_HARD_CFLAGS)
 
 AM_CPPFLAGS  = $(NTP_INCS)
 AM_CPPFLAGS += -I$(top_srcdir)/kernel
 AM_CPPFLAGS += $(CPPFLAGS_NTP)
+AM_CPPFLAGS += $(NTP_HARD_CPPFLAGS)
 
+AM_LDFLAGS = $(NTP_HARD_LDFLAGS)
+
 EXTRA_DIST = parsesolaris.c parsestreams.c mkinfo_scmd.sed mkinfo_rcmd.sed info_trimble.c
 
 info_trimble.c: $(top_srcdir)/include/trimble.h $(srcdir)/Makefile.am $(srcdir)/mkinfo_scmd.sed $(srcdir)/mkinfo_rcmd.sed
Index: contrib/ntp/libparse/gpstolfp.c
===================================================================
--- contrib/ntp/libparse/gpstolfp.c	(版本 314126)
+++ contrib/ntp/libparse/gpstolfp.c	(版本 316722)
@@ -39,8 +39,8 @@
 
 void
 gpstolfp(
-	 int weeks,
-	 int days,
+	 u_int weeks,
+	 u_int days,
 	 unsigned long  seconds,
 	 l_fp * lfp
 	 )
Index: contrib/ntp/libntp/ntp_intres.c
===================================================================
--- contrib/ntp/libntp/ntp_intres.c	(版本 314126)
+++ contrib/ntp/libntp/ntp_intres.c	(版本 316722)
@@ -410,7 +410,7 @@
 			cp += sizeof(*ai);
 
 			/* transform ai_canonname into offset */
-			if (NULL != serialized_ai->ai_canonname) {
+			if (NULL != ai->ai_canonname) {
 				serialized_ai->ai_canonname = (char *)canons_octets;
 				canons_octets += strlen(ai->ai_canonname) + 1;
 			}
Index: contrib/ntp/libntp/statestr.c
===================================================================
--- contrib/ntp/libntp/statestr.c	(版本 314126)
+++ contrib/ntp/libntp/statestr.c	(版本 316722)
@@ -355,13 +355,12 @@
 
 	for (b = 0; b < tab_ct; b++) {
 		if (tab[b].code & bits) {
-			rc = snprintf(pch, (lim - pch), "%s%s", sep,
+			size_t avail = lim - pch;
+			rc = snprintf(pch, avail, "%s%s", sep,
 				      tab[b].string);
-			if (rc < 0)
+			if ((size_t)rc >= avail)
 				goto toosmall;
-			pch += (u_int)rc;
-			if (pch >= lim)
-				goto toosmall;
+			pch += rc;
 			sep = sep2;
 		}
 	}
Index: contrib/ntp/ntpd/Makefile.am
===================================================================
--- contrib/ntp/ntpd/Makefile.am	(版本 314126)
+++ contrib/ntp/ntpd/Makefile.am	(版本 316722)
@@ -7,12 +7,15 @@
 noinst_LIBRARIES=	libntpd.a
 
 AM_CFLAGS = $(CFLAGS_NTP)
+AM_CFLAGS += $(NTP_HARD_CFLAGS)
 
 AM_CPPFLAGS  = $(NTP_INCS)
 AM_CPPFLAGS += $(LIBOPTS_CFLAGS)
 AM_CPPFLAGS += $(CPPFLAGS_NTP)
+AM_CPPFLAGS += $(NTP_HARD_CPPFLAGS)
 
 AM_LDFLAGS = $(LDFLAGS_NTP)
+AM_LDFLAGS += $(NTP_HARD_LDFLAGS)
 
 # LDADD might need RESLIB and ADJLIB.
 LDADD = version.o libntpd.a $(LIBPARSE)
Index: UPDATING
===================================================================
--- UPDATING	(版本 314126)
+++ UPDATING	(版本 316722)
@@ -16,6 +16,13 @@
 stable/10, and then rebuild without this option. The bootstrap process from
 older version of current is a bit fragile.
 
+20170412	p18	FreeBSD-SA-17:03.ntp
+			FreeBSD-EN-17:05.xen
+
+	Fix multiple vulnerabilities of ntp. [SA-17:03]
+
+	Xen migration enhancements. [EN-17:05]
+
 20170223	p17	FreeBSD-SA-17:02.openssl
 
 	Fix OpenSSL RC4_MD5 cipher vulnerability.
Index: contrib/ntp/COPYRIGHT
===================================================================
--- contrib/ntp/COPYRIGHT	(版本 314126)
+++ contrib/ntp/COPYRIGHT	(版本 316722)
@@ -4,7 +4,7 @@
   
    jpg "Clone me," says Dolly sheepishly.
    
-   Last update: 17-Jan-2015 00:16 UTC
+   Last update: 2-Jan-2017 11:58 UTC
      _________________________________________________________________
    
    The following copyright notice applies to all files collectively
@@ -33,7 +33,7 @@
    Burnicki is:
 ***********************************************************************
 *                                                                     *
-* Copyright (c) Network Time Foundation 2011-2015                     *
+* Copyright (c) Network Time Foundation 2011-2017                     *
 *                                                                     *
 * All Rights Reserved                                                 *
 *                                                                     *
Index: contrib/ntp/ChangeLog
===================================================================
--- contrib/ntp/ChangeLog	(版本 314126)
+++ contrib/ntp/ChangeLog	(版本 316722)
@@ -1,6 +1,77 @@
 ---
+(4.2.8p10-win-beta1) 2017/03/21 Released by Harlan Stenn <stenn@ntp.org>
+(4.2.8p10)
+
+* [Sec 3389] NTP-01-016: Denial of Service via Malformed Config
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3388] NTP-01-014: Buffer Overflow in DPTS Clock
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3387] NTP-01-012: Authenticated DoS via Malicious Config Option
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3386] NTP-01-011: ntpq_stripquotes() returns incorrect Value
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3385] NTP-01-010: ereallocarray()/eallocarray() underused. HStenn
+* [Sec 3384] NTP-01-009: Privileged execution of User Library code
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3383] NTP-01-008: Stack Buffer Overflow from Command Line
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3382] NTP-01-007: Data Structure terminated insufficiently
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3380] NTP-01-005: Off-by-one in Oncore GPS Receiver
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3379] NTP-01-004: Potential Overflows in ctl_put() functions
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3378] NTP-01-003: Improper use of snprintf() in mx4200_send()
+  (Pentest report 01.2017) <perlinger@ntp.org>
+* [Sec 3377] NTP-01-002: Buffer Overflow in ntpq when fetching reslist
+  (Pentest report 01.2017) <perlinger@ntp.org
+* [Sec 3376] Support build "hardening" flags.  stenn@ntp.org
+* [Sec 3361] 0rigin (zero origin) DoS.  HStenn.
+* [Bug 3393] clang scan-build findings <perlinger@ntp.org>
+* [Bug 3363] Support for openssl-1.1.0 without compatibility modes
+  - rework of patch set from <ntp.org@eroen.eu>. <perlinger@ntp.org>
+* [Bug 3356] Bugfix 3072 breaks multicastclient <perlinger@ntp.org>
+* [Bug 3216] libntp audio ioctl() args incorrectly cast to int
+  on 4.4BSD-Lite derived platforms <perlinger@ntp.org>
+  - original patch by Majdi S. Abbas
+* [Bug 3215] 'make distcheck' fails with new BK repo format <perlinger@ntp.org>
+* [Bug 3173] forking async worker: interrupted pipe I/O <perlinger@ntp.org>
+  - initial patch by Christos Zoulas
+* [Bug 3139] (...) time_pps_create: Exec format error <perlinger@ntp.org>
+  - move loader API from 'inline' to proper source
+  - augment pathless dlls with absolute path to NTPD
+  - use 'msyslog()' instead of 'printf() 'for reporting trouble
+* [Bug 3107] Incorrect Logic for Peer Event Limiting <perlinger@ntp.org>
+  - applied patch by Matthew Van Gundy
+* [Bug 3065] Quiet warnings on NetBSD <perlinger@ntp.org>
+  - applied some of the patches provided by Havard. Not all of them
+    still match the current code base, and I did not touch libopt.
+* [Bug 3062] Change the process name of forked DNS worker <perlinger@ntp.org>
+  - applied patch by Reinhard Max. See bugzilla for limitations.
+* [Bug 2923] Trap Configuration Fail <perlinger@ntp.org>
+  - fixed dependency inversion from [Bug 2837]
+* [Bug 2896] Nothing happens if minsane < maxclock < minclock
+  - produce ERROR log message about dysfunctional daemon. <perlinger@ntp.org>
+* [Bug 2851] allow -4/-6 on restrict line with mask <perlinger@ntp.org>
+  - applied patch by Miroslav Lichvar for ntp4.2.6 compat
+* [Bug 2645] out-of-bound pointers in ctl_putsys and decode_bitflags
+  - Fixed these and some more locations of this pattern.
+    Probably din't get them all, though. <perlinger@ntp.org>
+* Update copyright year.
+* bk-7 trigger updates
+
+---
+(4.2.8p9-win) 2017/02/01 Released by Harlan Stenn <stenn@ntp.org>
+
+* [Bug 3144] NTP does not build without openSSL. <perlinger@ntp.org>
+  - added missed changeset for automatic openssl lib detection
+  - fixed some minor warning issues
+* [Bug 3095]  More compatibility with openssl 1.1. <perlinger@ntp.org>
+* configure.ac cleanup.  stenn@ntp.org
+* openssl configure cleanup.  stenn@ntp.org
+
+---
 (4.2.8p9) 2016/11/21 Released by Harlan Stenn <stenn@ntp.org>
-(4.2.8p9) 2016/MM/DD Released by Harlan Stenn <stenn@ntp.org>
 
 * [Sec 3119] Trap crash <perlinger@ntp.org>
 * [Sec 3118] Mode 6 information disclosure and DDoS vector <perlinger@ntp.org>
